#ifndef MATHTOOLKIT_UNITCONVERSION_ANGLECASTING_H
#define MATHTOOLKIT_UNITCONVERSION_ANGLECASTING_H

#include "MathematicalConstants.h"

// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Units

namespace MathToolkit
{
	namespace UnitConversion
	{
		namespace AngleCasting
		{
			namespace Unit
			{
				struct Radian
				{
					static constexpr double getUnitAngleInSI() { return (1.0); }
				};

				struct Degree
				{
					static constexpr double getUnitAngleInSI() { return (MathToolkit::Numerics::MathematicalConstants::getPi() / 180.0); }
				};

			}
		};
	}
}

// Units
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Methods

namespace MathToolkit
{
	namespace UnitConversion
	{
		namespace AngleCasting
		{
			template <typename from, typename to>
			inline constexpr double cast(const double value)
			{
				return ((value * from::getUnitAngleInSI()) / to::getUnitAngleInSI());
			}

			template <typename from, typename to>
			inline constexpr double getScalingMultiplier()
			{
				return (from::getUnitAngleInSI() / to::getUnitAngleInSI());
			}
		}
	}
}

// Methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************

#endif // !MATHTOOLKIT_UNITCONVERSION_ANGLECASTING_H
