#ifndef CHEMTOOLKIT_GENERIC_CHEMICALELEMENTCATEGORY_H
#define CHEMTOOLKIT_GENERIC_CHEMICALELEMENTCATEGORY_H

#include <stdexcept>
#include <string>

#include "ReportException.h"


namespace ChemToolkit
{
	namespace Generic
	{
		class ChemicalElementCategory
		{
			using size_type = std::size_t;

// **********************************************************************************************************************************************************************************************************************************************************************************************
		// Constructors, destructor, and operators

		public:
			ChemicalElementCategory(const std::string& elementSymbol);
			virtual ~ChemicalElementCategory() = default;

			ChemicalElementCategory(const ChemicalElementCategory&) = default;
			ChemicalElementCategory(ChemicalElementCategory&&) noexcept = default;
			ChemicalElementCategory& operator=(const ChemicalElementCategory&) = default;
			ChemicalElementCategory& operator=(ChemicalElementCategory&&) noexcept = default;

		// Constructors, destructor, and operators
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
		// Public methods

			size_type period() const;
			size_type group() const;

		// Public methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
		// Private methods

		private:
			size_type getPeriod(const std::string& elementSymbol);
			size_type getGroup(const std::string& elementSymbol);

		// Private methods
// **********************************************************************************************************************************************************************************************************************************************************************************************

		private:
			size_type m_period;
			size_type m_group;
		};
	}
}

// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Public methods

inline std::size_t ChemToolkit::Generic::ChemicalElementCategory::period() const
{
	return m_period;
}

inline std::size_t ChemToolkit::Generic::ChemicalElementCategory::group() const
{
	return m_group;
}

// Public methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************

#endif // !CHEMTOOLKIT_GENERIC_CHEMICALELEMENTCATEGORY_H
