#ifndef CHEMTOOLKIT_GENERIC_CHEMICALPARAMETERS_H
#define CHEMTOOLKIT_GENERIC_CHEMICALPARAMETERS_H

#include <stdexcept>
#include <string>

#include "ReportException.h"


namespace ChemToolkit
{
	namespace Generic
	{
		class ChemicalParameters
		{
			using size_type = std::size_t;

// **********************************************************************************************************************************************************************************************************************************************************************************************
		// Constructors, destructor, and operators

		public:
			ChemicalParameters();
			virtual ~ChemicalParameters() = default;

			ChemicalParameters(const ChemicalParameters&) = default;
			ChemicalParameters(ChemicalParameters&&) noexcept = default;
			ChemicalParameters& operator=(const ChemicalParameters&) = default;
			ChemicalParameters& operator=(ChemicalParameters&&) noexcept = default;

		// Constructors, destructor, and operators
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
		// Public methods

			void initialize();
			void initializeFromInputFileTexts(const std::string& inputTexts);

		// Public methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
		// Access methods

			double spaceGroupPrecision() const;

		// Access methods
// **********************************************************************************************************************************************************************************************************************************************************************************************

		private:
			double m_spaceGroupPrecision;
		};
	}
}

// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Access methods

inline double ChemToolkit::Generic::ChemicalParameters::spaceGroupPrecision() const
{
	return m_spaceGroupPrecision;
}

// Access methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************


#endif // !CHEMTOOLKIT_GENERIC_CHEMICALPARAMETERS_H
