#ifndef MATHTOOLKIT_UNITCONVERSION_LENGTHCASTING_H
#define MATHTOOLKIT_UNITCONVERSION_LENGTHCASTING_H

#include <ratio>
#include <stdexcept>

#include "ReportException.h"

// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Units

namespace MathToolkit
{
	namespace UnitConversion
	{
		namespace LengthCasting
		{
			namespace Unit
			{
				struct AtomicUnit
				{
					static constexpr double getUnitLengthInSI() { return ((0.0529177210903 * static_cast<double>(std::nano::num)) / static_cast<double>(std::nano::den)); }
				};

				struct Angstrom
				{
					static constexpr double getUnitLengthInSI() { return ((0.1 * static_cast<double>(std::nano::num)) / static_cast<double>(std::nano::den)); }
				};

				template <typename Magnitude = std::ratio<1>>
				struct Metre
				{
					static constexpr double getUnitLengthInSI() { return (static_cast<double>(Magnitude::num) / static_cast<double>(Magnitude::den)); }
				};
			}
		}
	}
}

// Units
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Methods

namespace MathToolkit
{
	namespace UnitConversion
	{
		namespace LengthCasting
		{
			template <typename from, typename to>
			inline constexpr double cast(const double value)
			{
				return ((value * from::getUnitLengthInSI()) / to::getUnitLengthInSI());
			}

			template <typename from, typename to>
			inline constexpr double getScalingMultiplier()
			{
				return (from::getUnitLengthInSI() / to::getUnitLengthInSI());
			}
		}
	}
}

// Methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************

#endif // !MATHTOOLKIT_UNITCONVERSION_LENGTHCASTING_H
