#ifndef MATHTOOLKIT_UNITCONVERSION_MASSCASTING_H
#define MATHTOOLKIT_UNITCONVERSION_MASSCASTING_H

#include <ratio>
#include <stdexcept>

#include "ReportException.h"

// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Units

namespace MathToolkit
{
	namespace UnitConversion
	{
		namespace MassCasting
		{
			namespace Unit
			{
				struct AtomicUnit
				{
					static constexpr double getUnitMassInSI() { return (0.91093837015 / (static_cast<double>(std::peta::num) * static_cast<double>(std::peta::num))); }
				};

				template <typename Magnitude = std::ratio<1>>
				struct Gram
				{
					static constexpr double getUnitMassInSI() { return (static_cast<double>(Magnitude::num) / static_cast<double>(Magnitude::den)); }
				};
			}
		}
	}
}

// Units
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Methods

namespace MathToolkit
{
	namespace UnitConversion
	{
		namespace MassCasting
		{
			template <typename from, typename to>
			inline constexpr double cast(const double value)
			{
				return ((value * from::getUnitMassInSI()) / to::getUnitMassInSI());
			}

			template <typename from, typename to>
			inline constexpr double getScalingMultiplier()
			{
				return (from::getUnitMassInSI() / to::getUnitMassInSI());
			}
		}
	}
}

// Methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************

#endif // !MATHTOOLKIT_UNITCONVERSION_MASSCASTING_H
