#ifndef MATHEMATICALCRYSTALCHEMISTRY_DESIGN_GENERATION_RANDOMSTRUCTUREGENERATIONPARAMETERS_H
#define MATHEMATICALCRYSTALCHEMISTRY_DESIGN_GENERATION_RANDOMSTRUCTUREGENERATIONPARAMETERS_H

#include <stdexcept>
#include <string>


namespace MathematicalCrystalChemistry
{
	namespace Design
	{
		namespace Generation
		{
			class RandomStructureGenerationParameters
			{
// **********************************************************************************************************************************************************************************************************************************************************************************************
			// Constructors, destructor, and operators

			public:
				RandomStructureGenerationParameters();
				virtual ~RandomStructureGenerationParameters() = default;

				RandomStructureGenerationParameters(const RandomStructureGenerationParameters&) = default;
				RandomStructureGenerationParameters(RandomStructureGenerationParameters&&) = default;
				RandomStructureGenerationParameters& operator=(const RandomStructureGenerationParameters&) = default;
				RandomStructureGenerationParameters& operator=(RandomStructureGenerationParameters&&) = default;

			// Constructors, destructor, and operators
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
			// Public methods

				void initialize();
				void initializeFromInputFileTexts(const std::string& inputTexts);

			// Public methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
			// Access methods

				double initialPackingFraction() const;
				double maxInitialLatticeLengthRatio() const;
				double maxInitialLatticeAngle() const;
				double minInitialLatticeAngle() const;

			// Access methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
			// Private methods

			private:
				void validateParameters() const;

			// Private methods
// **********************************************************************************************************************************************************************************************************************************************************************************************

			private:
				double m_initialPackingFraction;
				double m_maxInitialLatticeLengthRatio;
				double m_maxInitialLatticeAngle;
				double m_minInitialLatticeAngle;
			};
		}
	}
}

// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Access methods

inline double MathematicalCrystalChemistry::Design::Generation::RandomStructureGenerationParameters::initialPackingFraction() const
{
	return m_initialPackingFraction;
}

inline double MathematicalCrystalChemistry::Design::Generation::RandomStructureGenerationParameters::maxInitialLatticeLengthRatio() const
{
	return m_maxInitialLatticeLengthRatio;
}

inline double MathematicalCrystalChemistry::Design::Generation::RandomStructureGenerationParameters::maxInitialLatticeAngle() const
{
	return m_maxInitialLatticeAngle;
}

inline double MathematicalCrystalChemistry::Design::Generation::RandomStructureGenerationParameters::minInitialLatticeAngle() const
{
	return m_minInitialLatticeAngle;
}

// Access methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************


#endif // !MATHEMATICALCRYSTALCHEMISTRY_DESIGN_GENERATION_RANDOMSTRUCTUREGENERATIONPARAMETERS_H
