#ifndef MATHEMATICALCRYSTALCHEMISTRY_IO_STRUCTUREREPORTER_H
#define MATHEMATICALCRYSTALCHEMISTRY_IO_STRUCTUREREPORTER_H

#include <stdexcept>
#include <string>
#include <filesystem>

#include "ModelCrystalStructure.h"


namespace MathematicalCrystalChemistry
{
	namespace IO
	{
		class StructureReporter
		{
			using size_type = std::size_t;
			using ModelCrystalStructure = MathematicalCrystalChemistry::StructureModel::Components::ModelCrystalStructure;

// **********************************************************************************************************************************************************************************************************************************************************************************************
		// Constructors, destructor and operators

		public:
			StructureReporter() = default;
			virtual ~StructureReporter() = default;

			StructureReporter(const StructureReporter&) = default;
			StructureReporter(StructureReporter&&) noexcept = default;
			StructureReporter& operator=(const StructureReporter&) = default;
			StructureReporter& operator=(StructureReporter&&) noexcept = default;

		// Constructors, destructor and operators
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
		// Public methods

			void report(const ModelCrystalStructure&, const std::filesystem::path& outputDirectoryPath) const;

		// Public methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
		// Private methods

		private:


		// Private methods
// **********************************************************************************************************************************************************************************************************************************************************************************************

		private:
			static std::string m_filename;
		};
	}
}




#endif // !MATHEMATICALCRYSTALCHEMISTRY_IO_STRUCTUREREPORTER_H

