#ifndef MATHTOOLKIT_UNITCONVERSION_TIMECASTING_H
#define MATHTOOLKIT_UNITCONVERSION_TIMECASTING_H

#include <ratio>
#include <stdexcept>

#include "ReportException.h"

// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Units

namespace MathToolkit
{
	namespace UnitConversion
	{
		namespace TimeCasting
		{
			namespace Unit
			{
				struct AtomicUnit
				{
					static constexpr double getUnitTimeInSI() { return ((0.024188843265857 * static_cast<double>(std::femto::num)) / static_cast<double>(std::femto::den)); }
				};

				template <typename Magnitude = std::ratio<1>>
				struct Second
				{
					static constexpr double getUnitTimeInSI() { return (static_cast<double>(Magnitude::num) / static_cast<double>(Magnitude::den)); }
				};

				struct Minute
				{
					static constexpr double getUnitTimeInSI() { return 60.0; }
				};

				struct Hour
				{
					static constexpr double getUnitTimeInSI() { return 3600.0; }
				};
			}
		}
	}
}

// Units
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Methods

namespace MathToolkit
{
	namespace UnitConversion
	{
		namespace TimeCasting
		{
			template <typename from, typename to>
			inline constexpr double cast(const double value)
			{
				return ((value * from::getUnitTimeInSI()) / to::getUnitTimeInSI());
			}

			template <typename from, typename to>
			inline constexpr double getScalingMultiplier()
			{
				return (from::getUnitTimeInSI() / to::getUnitTimeInSI());
			}
		}
	}
}

// Methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************

#endif // !MATHTOOLKIT_UNITCONVERSION_TIMECASTING_H
