#include "AnionicConstraint.h"

using namespace MathematicalCrystalChemistry::StructureModel::GeometricalConstraints;


// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Constructors

double AnionicConstraint::m_defaultCutoffRatio{ 2.0 };


AnionicConstraint::AnionicConstraint(ModelAtom& modelAtom, const Ligand& li)
	: MinimumDistanceConstraint{ modelAtom, li }
{
	MinimumDistanceConstraint::setMinimumDistance(modelAtomRef().coordinationFeature().repulsiveIonicRadius() + ligand().get().coordinationFeature().repulsiveIonicRadius());
}

AnionicConstraint::AnionicConstraint(ModelAtom& modelAtom, Ligand&& li)
	: MinimumDistanceConstraint{ modelAtom, std::move(li) }
{
	MinimumDistanceConstraint::setMinimumDistance(modelAtomRef().coordinationFeature().repulsiveIonicRadius() + ligand().get().coordinationFeature().repulsiveIonicRadius());
}

AnionicConstraint::AnionicConstraint(const Ligand& la, const Ligand& lb)
	: MinimumDistanceConstraint{ la, lb }
{
	MinimumDistanceConstraint::setMinimumDistance(modelAtomRef().coordinationFeature().repulsiveIonicRadius() + ligand().get().coordinationFeature().repulsiveIonicRadius());
}

AnionicConstraint::AnionicConstraint(const std::shared_ptr<AnionicConstraint>& reversePtr)
	: MinimumDistanceConstraint{ std::dynamic_pointer_cast<MinimumDistanceConstraint>(reversePtr) }
{
}

// Constructors
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
