#include "AtomCategory.h"

using namespace MathematicalCrystalChemistry::StructureModel::Features;


// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Constructor

AtomCategory::AtomCategory()
	: m_item{ Item::chemical_element }
{
}

AtomCategory::AtomCategory(const std::string& categorySymbol)
	: m_item{ Item::chemical_element }
{
	if (categorySymbol == "METAL" || categorySymbol == "Metal" || categorySymbol == "metal" || categorySymbol == "M")
		m_item = Item::metal;
	else if (categorySymbol == "OXIDE_ION" || categorySymbol == "Oxide_ion" || categorySymbol == "oxide_ion" || categorySymbol == "O")
		m_item = Item::oxide_ion;
	else if (categorySymbol == "ANION" || categorySymbol == "Anion" || categorySymbol == "anion" || categorySymbol == "A")
		m_item = Item::anion;
	else
	{
		std::string errorMessage;
		{
			errorMessage += "\"";
			errorMessage += categorySymbol;
			errorMessage += "\" is not a symbol of atom category.";
		}

		OperatingSystem::Configuration::ReportException reportException;
		throw std::invalid_argument(reportException(typeid(*this), "constructor", errorMessage));
	}
}

// Constructor
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Static methods

AtomCategory AtomCategory::toAtomCategory(const std::string& elementSymbol)
{
	AtomCategory atomCategory;
	{
		if (elementSymbol == "H")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Li")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Be")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "B")
			atomCategory.m_item = Item::anion;
		if (elementSymbol == "C")
			atomCategory.m_item = Item::anion;
		if (elementSymbol == "N")
			atomCategory.m_item = Item::anion;
		if (elementSymbol == "O")
			atomCategory.m_item = Item::oxide_ion;
		if (elementSymbol == "F")
			atomCategory.m_item = Item::anion;
		if (elementSymbol == "Na")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Mg")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Al")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Si")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "P")
			atomCategory.m_item = Item::anion;
		if (elementSymbol == "S")
			atomCategory.m_item = Item::anion;
		if (elementSymbol == "Cl")
			atomCategory.m_item = Item::anion;
		if (elementSymbol == "K")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Ca")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Sc")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Ti")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "V")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Cr")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Mn")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Fe")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Co")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Ni")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Cu")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Zn")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Ga")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Ge")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "As")
			atomCategory.m_item = Item::anion;
		if (elementSymbol == "Se")
			atomCategory.m_item = Item::anion;
		if (elementSymbol == "Br")
			atomCategory.m_item = Item::anion;
		if (elementSymbol == "Rb")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Sr")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Y")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Zr")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Nb")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Mo")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Tc")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Ru")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Rh")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Pd")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Ag")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Cd")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "In")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Sn")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Sb")
			atomCategory.m_item = Item::anion;
		if (elementSymbol == "Te")
			atomCategory.m_item = Item::anion;
		if (elementSymbol == "I")
			atomCategory.m_item = Item::anion;
		if (elementSymbol == "Cs")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Ba")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "La")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Ce")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Pr")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Nd")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Pm")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Sm")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Eu")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Gd")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Tb")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Dy")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Ho")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Er")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Tm")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Yb")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Lu")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Hf")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Ta")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "W")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Re")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Os")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Ir")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Pt")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Au")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Hg")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Tl")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Pb")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Bi")
			atomCategory.m_item = Item::anion;
		if (elementSymbol == "Po")
			atomCategory.m_item = Item::anion;
		if (elementSymbol == "At")
			atomCategory.m_item = Item::anion;
		if (elementSymbol == "Fr")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Ra")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Ac")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Th")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "Pa")
			atomCategory.m_item = Item::metal;
		if (elementSymbol == "U")
			atomCategory.m_item = Item::metal;
	}


	if (atomCategory.m_item == Item::chemical_element)
	{
		std::string errorMessage;
		{
			errorMessage += "Element symbol  of \"";
			errorMessage += elementSymbol;
			errorMessage += "\" is out of definitions";
		}

		OperatingSystem::Configuration::ReportException reportException;
		throw std::invalid_argument(reportException("toAtomCategory of MathematicalCrystalChemistry::StructureModel::Features::AtomCategory", errorMessage));
	}

	else
		return atomCategory;
}

// Static methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
