#include "CationicConstraint.h"

using namespace MathematicalCrystalChemistry::StructureModel::GeometricalConstraints;


// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Constructors

CationicConstraint::CationicConstraint(ModelAtom& modelAtom, const Ligand& li)
	: MinimumDistanceConstraint{ modelAtom, li }
{
	MinimumDistanceConstraint::setMinimumDistance(modelAtomRef().coordinationFeature().repulsiveIonicRadius() + ligand().get().coordinationFeature().repulsiveIonicRadius());
}

CationicConstraint::CationicConstraint(ModelAtom& modelAtom, Ligand&& li)
	: MinimumDistanceConstraint{ modelAtom, std::move(li) }
{
	MinimumDistanceConstraint::setMinimumDistance(modelAtomRef().coordinationFeature().repulsiveIonicRadius() + ligand().get().coordinationFeature().repulsiveIonicRadius());
}

CationicConstraint::CationicConstraint(const Ligand& la, const Ligand& lb)
	: MinimumDistanceConstraint{ la, lb }
{
	MinimumDistanceConstraint::setMinimumDistance(modelAtomRef().coordinationFeature().repulsiveIonicRadius() + ligand().get().coordinationFeature().repulsiveIonicRadius());
}

CationicConstraint::CationicConstraint(const std::shared_ptr<CationicConstraint>& reversePtr)
	: MinimumDistanceConstraint{ std::dynamic_pointer_cast<MinimumDistanceConstraint>(reversePtr) }
{
}

// Constructors
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
