#include "ChemicalElementCategory.h"

using namespace ChemToolkit::Generic;


// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Constructor

ChemicalElementCategory::ChemicalElementCategory(const std::string& elementSymbol)
	: m_period{ getPeriod(elementSymbol) }
	, m_group{ getGroup(elementSymbol) }
{
}

// Constructor
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Static methods

std::size_t ChemicalElementCategory::getPeriod(const std::string& elementSymbol)
{
	if (elementSymbol == "H")
		return 1;
	if (elementSymbol == "Li")
		return 2;
	if (elementSymbol == "Be")
		return 2;
	if (elementSymbol == "B")
		return 2;
	if (elementSymbol == "C")
		return 2;
	if (elementSymbol == "N")
		return 2;
	if (elementSymbol == "O")
		return 2;
	if (elementSymbol == "F")
		return 2;
	if (elementSymbol == "Na")
		return 3;
	if (elementSymbol == "Mg")
		return 3;
	if (elementSymbol == "Al")
		return 3;
	if (elementSymbol == "Si")
		return 3;
	if (elementSymbol == "P")
		return 3;
	if (elementSymbol == "S")
		return 3;
	if (elementSymbol == "Cl")
		return 3;
	if (elementSymbol == "K")
		return 4;
	if (elementSymbol == "Ca")
		return 4;
	if (elementSymbol == "Sc")
		return 4;
	if (elementSymbol == "Ti")
		return 4;
	if (elementSymbol == "V")
		return 4;
	if (elementSymbol == "Cr")
		return 4;
	if (elementSymbol == "Mn")
		return 4;
	if (elementSymbol == "Fe")
		return 4;
	if (elementSymbol == "Co")
		return 4;
	if (elementSymbol == "Ni")
		return 4;
	if (elementSymbol == "Cu")
		return 4;
	if (elementSymbol == "Zn")
		return 4;
	if (elementSymbol == "Ga")
		return 4;
	if (elementSymbol == "Ge")
		return 4;
	if (elementSymbol == "As")
		return 4;
	if (elementSymbol == "Se")
		return 4;
	if (elementSymbol == "Br")
		return 4;
	if (elementSymbol == "Rb")
		return 5;
	if (elementSymbol == "Sr")
		return 5;
	if (elementSymbol == "Y")
		return 5;
	if (elementSymbol == "Zr")
		return 5;
	if (elementSymbol == "Nb")
		return 5;
	if (elementSymbol == "Mo")
		return 5;
	if (elementSymbol == "Tc")
		return 5;
	if (elementSymbol == "Ru")
		return 5;
	if (elementSymbol == "Rh")
		return 5;
	if (elementSymbol == "Pd")
		return 5;
	if (elementSymbol == "Ag")
		return 5;
	if (elementSymbol == "Cd")
		return 5;
	if (elementSymbol == "In")
		return 5;
	if (elementSymbol == "Sn")
		return 5;
	if (elementSymbol == "Sb")
		return 5;
	if (elementSymbol == "Te")
		return 5;
	if (elementSymbol == "I")
		return 5;
	if (elementSymbol == "Cs")
		return 6;
	if (elementSymbol == "Ba")
		return 6;
	if (elementSymbol == "La")
		return 6;
	if (elementSymbol == "Ce")
		return 6;
	if (elementSymbol == "Pr")
		return 6;
	if (elementSymbol == "Nd")
		return 6;
	if (elementSymbol == "Pm")
		return 6;
	if (elementSymbol == "Sm")
		return 6;
	if (elementSymbol == "Eu")
		return 6;
	if (elementSymbol == "Gd")
		return 6;
	if (elementSymbol == "Tb")
		return 6;
	if (elementSymbol == "Dy")
		return 6;
	if (elementSymbol == "Ho")
		return 6;
	if (elementSymbol == "Er")
		return 6;
	if (elementSymbol == "Tm")
		return 6;
	if (elementSymbol == "Yb")
		return 6;
	if (elementSymbol == "Lu")
		return 6;
	if (elementSymbol == "Hf")
		return 6;
	if (elementSymbol == "Ta")
		return 6;
	if (elementSymbol == "W")
		return 6;
	if (elementSymbol == "Re")
		return 6;
	if (elementSymbol == "Os")
		return 6;
	if (elementSymbol == "Ir")
		return 6;
	if (elementSymbol == "Pt")
		return 6;
	if (elementSymbol == "Au")
		return 6;
	if (elementSymbol == "Hg")
		return 6;
	if (elementSymbol == "Tl")
		return 6;
	if (elementSymbol == "Pb")
		return 6;
	if (elementSymbol == "Bi")
		return 6;
	if (elementSymbol == "Po")
		return 6;
	if (elementSymbol == "At")
		return 6;
	if (elementSymbol == "Fr")
		return 7;
	if (elementSymbol == "Ra")
		return 7;
	if (elementSymbol == "Ac")
		return 7;
	if (elementSymbol == "Th")
		return 7;
	if (elementSymbol == "Pa")
		return 7;
	if (elementSymbol == "U")
		return 7;


	std::string errorMessage;
	{
		errorMessage += "Element symbol  of \"";
		errorMessage += elementSymbol;
		errorMessage += "\" is out of definitions";
	}

	OperatingSystem::Configuration::ReportException reportException;
	throw std::invalid_argument(reportException("toAtomCategory of MathematicalCrystalChemistry::StructureModel::Features::AtomCategory", errorMessage));
}

std::size_t ChemicalElementCategory::getGroup(const std::string& elementSymbol)
{
	if (elementSymbol == "H")
		return 1;
	if (elementSymbol == "Li")
		return 1;
	if (elementSymbol == "Be")
		return 2;
	if (elementSymbol == "B")
		return 13;
	if (elementSymbol == "C")
		return 14;
	if (elementSymbol == "N")
		return 15;
	if (elementSymbol == "O")
		return 16;
	if (elementSymbol == "F")
		return 17;
	if (elementSymbol == "Na")
		return 1;
	if (elementSymbol == "Mg")
		return 2;
	if (elementSymbol == "Al")
		return 13;
	if (elementSymbol == "Si")
		return 14;
	if (elementSymbol == "P")
		return 15;
	if (elementSymbol == "S")
		return 16;
	if (elementSymbol == "Cl")
		return 17;
	if (elementSymbol == "K")
		return 1;
	if (elementSymbol == "Ca")
		return 2;
	if (elementSymbol == "Sc")
		return 3;
	if (elementSymbol == "Ti")
		return 4;
	if (elementSymbol == "V")
		return 5;
	if (elementSymbol == "Cr")
		return 6;
	if (elementSymbol == "Mn")
		return 7;
	if (elementSymbol == "Fe")
		return 8;
	if (elementSymbol == "Co")
		return 9;
	if (elementSymbol == "Ni")
		return 10;
	if (elementSymbol == "Cu")
		return 11;
	if (elementSymbol == "Zn")
		return 12;
	if (elementSymbol == "Ga")
		return 13;
	if (elementSymbol == "Ge")
		return 14;
	if (elementSymbol == "As")
		return 15;
	if (elementSymbol == "Se")
		return 16;
	if (elementSymbol == "Br")
		return 17;
	if (elementSymbol == "Rb")
		return 1;
	if (elementSymbol == "Sr")
		return 2;
	if (elementSymbol == "Y")
		return 3;
	if (elementSymbol == "Zr")
		return 4;
	if (elementSymbol == "Nb")
		return 5;
	if (elementSymbol == "Mo")
		return 6;
	if (elementSymbol == "Tc")
		return 7;
	if (elementSymbol == "Ru")
		return 8;
	if (elementSymbol == "Rh")
		return 9;
	if (elementSymbol == "Pd")
		return 10;
	if (elementSymbol == "Ag")
		return 11;
	if (elementSymbol == "Cd")
		return 12;
	if (elementSymbol == "In")
		return 13;
	if (elementSymbol == "Sn")
		return 14;
	if (elementSymbol == "Sb")
		return 15;
	if (elementSymbol == "Te")
		return 16;
	if (elementSymbol == "I")
		return 17;
	if (elementSymbol == "Cs")
		return 1;
	if (elementSymbol == "Ba")
		return 2;
	if (elementSymbol == "La")
		return 3;
	if (elementSymbol == "Ce")
		return 3;
	if (elementSymbol == "Pr")
		return 3;
	if (elementSymbol == "Nd")
		return 3;
	if (elementSymbol == "Pm")
		return 3;
	if (elementSymbol == "Sm")
		return 3;
	if (elementSymbol == "Eu")
		return 3;
	if (elementSymbol == "Gd")
		return 3;
	if (elementSymbol == "Tb")
		return 3;
	if (elementSymbol == "Dy")
		return 3;
	if (elementSymbol == "Ho")
		return 3;
	if (elementSymbol == "Er")
		return 3;
	if (elementSymbol == "Tm")
		return 3;
	if (elementSymbol == "Yb")
		return 3;
	if (elementSymbol == "Lu")
		return 3;
	if (elementSymbol == "Hf")
		return 4;
	if (elementSymbol == "Ta")
		return 5;
	if (elementSymbol == "W")
		return 6;
	if (elementSymbol == "Re")
		return 7;
	if (elementSymbol == "Os")
		return 8;
	if (elementSymbol == "Ir")
		return 9;
	if (elementSymbol == "Pt")
		return 10;
	if (elementSymbol == "Au")
		return 11;
	if (elementSymbol == "Hg")
		return 12;
	if (elementSymbol == "Tl")
		return 13;
	if (elementSymbol == "Pb")
		return 14;
	if (elementSymbol == "Bi")
		return 15;
	if (elementSymbol == "Po")
		return 16;
	if (elementSymbol == "At")
		return 17;
	if (elementSymbol == "Fr")
		return 1;
	if (elementSymbol == "Ra")
		return 2;
	if (elementSymbol == "Ac")
		return 3;
	if (elementSymbol == "Th")
		return 3;
	if (elementSymbol == "Pa")
		return 3;
	if (elementSymbol == "U")
		return 3;


	std::string errorMessage;
	{
		errorMessage += "Element symbol  of \"";
		errorMessage += elementSymbol;
		errorMessage += "\" is out of definitions";
	}

	OperatingSystem::Configuration::ReportException reportException;
	throw std::invalid_argument(reportException("toAtomCategory of MathematicalCrystalChemistry::StructureModel::Features::AtomCategory", errorMessage));
}

// Static methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
