#include "CifFileExcavator.h"

#include "MpiController.h"
#include "ThreadController.h"
#include "LogWriter.h"

using namespace ChemToolkit::Crystallography::FileIO;


// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Constructor

CifFileExcavator::CifFileExcavator(const size_type threadRank)
	: m_threadRank{ threadRank }
	, m_cifFileReader{}
{
}

// Constructor
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Public methods

void CifFileExcavator::excavateNextCifFile()
{
	++m_recursiveCifDataDirectoryIter;
	m_cifFileReader.releaseFile();

	std::filesystem::path cifFilePath;
	{
		size_type cifFileFinding = 0;
		const size_type searchingCifFileFinding = (OperatingSystem::Configuration::MpiController::mpiProcessing() * OperatingSystem::Configuration::ThreadController::maxThreading());


		for (; m_recursiveCifDataDirectoryIter != std::filesystem::end(m_recursiveCifDataDirectoryIter); ++m_recursiveCifDataDirectoryIter)
		{
			if (m_recursiveCifDataDirectoryIter->is_regular_file())
			{
				std::filesystem::path filePath = m_recursiveCifDataDirectoryIter->path();

				if (CifFileReader::isCorrectExtension(filePath))
				{
					++cifFileFinding;

					if (cifFileFinding == searchingCifFileFinding)
					{
						cifFilePath = std::move(filePath);
						break;
					}
				}
			}
		}
	}


	if (!(cifFilePath.empty()))
		m_cifFileReader = CifFileReader{ cifFilePath };
}

// Public methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Private methods

void CifFileExcavator::initializeCifFileReader()
{
	m_cifFileReader.releaseFile();

	std::filesystem::path cifFilePath;
	{
		size_type cifFileFinding = 0;
		size_type searchingCifFileFinding = (OperatingSystem::Configuration::MpiController::mpiRank() * OperatingSystem::Configuration::ThreadController::maxThreading());
		searchingCifFileFinding += (m_threadRank + 1);

		for (; m_recursiveCifDataDirectoryIter != std::filesystem::end(m_recursiveCifDataDirectoryIter); ++m_recursiveCifDataDirectoryIter)
		{
			if (m_recursiveCifDataDirectoryIter->is_regular_file())
			{
				std::filesystem::path filePath = m_recursiveCifDataDirectoryIter->path();

				if (CifFileReader::isCorrectExtension(filePath))
				{
					++cifFileFinding;

					if (cifFileFinding == searchingCifFileFinding)
					{
						cifFilePath = std::move(filePath);
						break;
					}
				}
			}
		}
	}


	if (!(cifFilePath.empty()))
		m_cifFileReader = CifFileReader{ cifFilePath };
}

// Private methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
