#include "CoordinationCenterBase.h"

#include "LengthCasting.h"

using namespace MathematicalCrystalChemistry::StructureModel::Components::Internal;


// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Constructors

double CoordinationCenterBase::m_pointGroupPrecision = MathToolkit::UnitConversion::LengthCasting::cast<MathToolkit::UnitConversion::LengthCasting::Unit::Angstrom, MathToolkit::UnitConversion::LengthCasting::Unit::AtomicUnit>(0.1);
double CoordinationCenterBase::m_defaultPointGroupPrecision = MathToolkit::UnitConversion::LengthCasting::cast<MathToolkit::UnitConversion::LengthCasting::Unit::Angstrom, MathToolkit::UnitConversion::LengthCasting::Unit::AtomicUnit>(0.1);


CoordinationCenterBase::CoordinationCenterBase(const std::string& elementSymbol)
	: m_coordinationFeature{}
	, m_attractiveForceConstant{ 30.0 }
	, m_repulsiveForceConstant{ -100.0 }
{
}

CoordinationCenterBase::CoordinationCenterBase(const std::string& elementSymbol, const CoordinationFeatureSymbol& coordinationFeatureSymbol)
	: m_coordinationFeature{ coordinationFeatureSymbol }
	, m_attractiveForceConstant{ 30.0 }
	, m_repulsiveForceConstant{ -100.0 }
{
}

CoordinationCenterBase::CoordinationCenterBase(const CoordinationCenterBase& coordinationCenterBase)
	: m_coordinationFeature{ coordinationCenterBase.m_coordinationFeature }
	, m_attractiveForceConstant{ 30.0 }
	, m_repulsiveForceConstant{ -100.0 }
{
}

CoordinationCenterBase::CoordinationCenterBase(CoordinationCenterBase&& coordinationCenterBase)
	: m_coordinationFeature{ coordinationCenterBase.m_coordinationFeature }
	, m_attractiveForceConstant{ 30.0 }
	, m_repulsiveForceConstant{ -100.0 }
{
}

CoordinationCenterBase& CoordinationCenterBase::operator=(const CoordinationCenterBase& coordinationCenterBase)
{
	m_coordinationFeature = coordinationCenterBase.m_coordinationFeature;
	return *this;
}

CoordinationCenterBase& CoordinationCenterBase::operator=(CoordinationCenterBase&& coordinationCenterBase)
{
	m_coordinationFeature = coordinationCenterBase.m_coordinationFeature;
	return *this;
}

// Constructors
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
