#include "CrystalAnalysisOptions.h"

#include "FileReader.h"

using namespace MathematicalCrystalChemistry::Analysis;


// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Public methods

void CrystalAnalysisOptions::initialize()
{
	m_chemicalCompositionConstraints.initialize();
	m_coordinationPolyhedraConstraints.initialize();
	m_wholeStructuralConstraints.initialize();
}

void CrystalAnalysisOptions::initializeFromFiles(const std::vector<std::filesystem::path>& filePaths)
{
	std::string inputTexts;
	{
		for (const std::filesystem::path& filePath : filePaths)
		{
			OperatingSystem::IO::FileReader fileReader{ filePath };
			inputTexts += fileReader.readFile();
		}
	}

	m_chemicalCompositionConstraints.initializeFromInputFileTexts(inputTexts);
	m_coordinationPolyhedraConstraints.initializeFromInputFileTexts(inputTexts);
	m_wholeStructuralConstraints.initializeFromInputFileTexts(inputTexts);
}

// Public methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
