#include "InitialStructureGenerationOptions.h"

#include <regex>
#include <sstream>

#include "FileReader.h"

using namespace MathematicalCrystalChemistry::Design::Generation;


// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Constructor

InitialStructureGenerationOptions::InitialStructureGenerationOptions()
	: m_structureGenerating{}
	, m_randomStructureGenerationParameters{}
{
}

// Constructor
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Public methods

void InitialStructureGenerationOptions::initialize()
{
	m_structureGenerating.clear();
	m_randomStructureGenerationParameters.initialize();
}

void InitialStructureGenerationOptions::initializeFromFiles(const std::vector<std::filesystem::path>& filePaths)
{
	initialize();

	std::string inputTexts;
	{
		for (const auto& filePath : filePaths)
		{
			OperatingSystem::IO::FileReader fileReader{ filePath };
			inputTexts += fileReader.readFile();
		}
	}

	readStructureGenerating(inputTexts);
	m_randomStructureGenerationParameters.initializeFromInputFileTexts(inputTexts);
}

// Constructor
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Public methods

void InitialStructureGenerationOptions::readStructureGenerating(const std::string& inputTexts)
{
	std::regex pat("[\\s]*([[:alpha:]]+)+[\\s]+([\\d]+)([\\s])*");

	for (const auto& lineData : OperatingSystem::IO::FileReader::readDataEnumeration(inputTexts, "Number.of.Initial.Structure.Generation"))
	{
		std::smatch sm;
		std::string stringLine;
		{
			for (const auto& text : lineData)
			{
				stringLine += text;
				stringLine += "  ";
			}

			stringLine.pop_back();
			stringLine.pop_back();
		}

		if (std::regex_match(stringLine, sm, pat))
			m_structureGenerating.emplace(translateIntoGenerationType(sm.str(1)), static_cast<size_type>(std::stoi(sm.str(2))));
	}
}

// Public methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
