#include "InteratomicConstraintBase.h"

using namespace MathematicalCrystalChemistry::StructureModel::GeometricalConstraints::Internal;


// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Protected constructors

InteratomicConstraintBase::InteratomicConstraintBase(ModelAtom& modelAtom, const Ligand& ligand)
	: m_reversePtr{}
	, m_modelAtomRef{ std::ref(modelAtom) }
	, m_ligand{ ligand }
{
}

InteratomicConstraintBase::InteratomicConstraintBase(ModelAtom& modelAtom, Ligand&& ligand)
	: m_reversePtr{}
	, m_modelAtomRef{ std::ref(modelAtom) }
	, m_ligand{ std::move(ligand) }
{
}

InteratomicConstraintBase::InteratomicConstraintBase(const Ligand& la, const Ligand& lb)
	: m_reversePtr{}
	, m_modelAtomRef{ std::ref(la.get()) }
	, m_ligand{ lb, lb.latticeSystemRef(), la.getRelativeLatticePointTo(lb) }
{
}

InteratomicConstraintBase::InteratomicConstraintBase(const std::shared_ptr<InteratomicConstraintBase>& reversePtr)
	: m_reversePtr{ reversePtr }
	, m_modelAtomRef{ std::ref(reversePtr->m_ligand.get()) }
	, m_ligand{ reversePtr->m_modelAtomRef, reversePtr->m_ligand }
{
	m_ligand.reverseLatticePoint();
}

// Protected constructors
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
