#include "InternationalTables.h"

#include "LengthCasting.h"

using namespace ChemToolkit::Crystallography::SpaceGroups;


// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Static members

double InternationalTables::m_spaceGroupPrecision = MathToolkit::UnitConversion::LengthCasting::cast<MathToolkit::UnitConversion::LengthCasting::Unit::Angstrom, MathToolkit::UnitConversion::LengthCasting::Unit::AtomicUnit>(0.1);
double InternationalTables::m_defaultSpaceGroupPrecision = MathToolkit::UnitConversion::LengthCasting::cast<MathToolkit::UnitConversion::LengthCasting::Unit::Angstrom, MathToolkit::UnitConversion::LengthCasting::Unit::AtomicUnit>(0.1);


// Static members
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Public methods

std::string InternationalTables::transformIntoShortSymbol(const size_type spaceGroupNumber)
{
	switch (spaceGroupNumber)
	{
	case 1:
		return std::string{ "P1" };
	case 2:
		return std::string{ "P-1" };
	case 3:
		return std::string{ "P2" };
	case 4:
		return std::string{ "P2_1" };
	case 5:
		return std::string{ "C2" };
	case 6:
		return std::string{ "Pm" };
	case 7:
		return std::string{ "Pc" };
	case 8:
		return std::string{ "Cm" };
	case 9:
		return std::string{ "Cc" };
	case 10:
		return std::string{ "P2/m" };
	case 11:
		return std::string{ "P2_1/m" };
	case 12:
		return std::string{ "C2/m" };
	case 13:
		return std::string{ "P2/c" };
	case 14:
		return std::string{ "P2_1/c" };
	case 15:
		return std::string{ "C2/c" };
	case 16:
		return std::string{ "P222" };
	case 17:
		return std::string{ "P222_1" };
	case 18:
		return std::string{ "P2_12_12" };
	case 19:
		return std::string{ "P2_12_12_1" };
	case 20:
		return std::string{ "C222_1" };
	case 21:
		return std::string{ "C222" };
	case 22:
		return std::string{ "F222" };
	case 23:
		return std::string{ "I222" };
	case 24:
		return std::string{ "I2_12_12_1" };
	case 25:
		return std::string{ "Pmm2" };
	case 26:
		return std::string{ "Pmc2_1" };
	case 27:
		return std::string{ "Pcc2" };
	case 28:
		return std::string{ "Pma2" };
	case 29:
		return std::string{ "Pca2_1" };
	case 30:
		return std::string{ "Pnc2" };
	case 31:
		return std::string{ "Pmn2_1" };
	case 32:
		return std::string{ "Pba2" };
	case 33:
		return std::string{ "Pna2_1" };
	case 34:
		return std::string{ "Pnn2" };
	case 35:
		return std::string{ "Cmm2" };
	case 36:
		return std::string{ "Cmc2_1" };
	case 37:
		return std::string{ "Ccc2" };
	case 38:
		return std::string{ "Amm2" };
	case 39:
		return std::string{ "Aem2" };
	case 40:
		return std::string{ "Ama2" };
	case 41:
		return std::string{ "Aea2" };
	case 42:
		return std::string{ "Fmm2" };
	case 43:
		return std::string{ "Fdd2" };
	case 44:
		return std::string{ "Imm2" };
	case 45:
		return std::string{ "Iba2" };
	case 46:
		return std::string{ "Ima2" };
	case 47:
		return std::string{ "Pmmm" };
	case 48:
		return std::string{ "Pnnn" };
	case 49:
		return std::string{ "Pccm" };
	case 50:
		return std::string{ "Pban" };
	case 51:
		return std::string{ "Pmma" };
	case 52:
		return std::string{ "Pnna" };
	case 53:
		return std::string{ "Pmna" };
	case 54:
		return std::string{ "Pcca" };
	case 55:
		return std::string{ "Pbam" };
	case 56:
		return std::string{ "Pccn" };
	case 57:
		return std::string{ "Pbcm" };
	case 58:
		return std::string{ "Pnnm" };
	case 59:
		return std::string{ "Pmmn" };
	case 60:
		return std::string{ "Pbcn" };
	case 61:
		return std::string{ "Pbca" };
	case 62:
		return std::string{ "Pnma" };
	case 63:
		return std::string{ "Cmcm" };
	case 64:
		return std::string{ "Cmce" };
	case 65:
		return std::string{ "Cmmm" };
	case 66:
		return std::string{ "Cccm" };
	case 67:
		return std::string{ "Cmme" };
	case 68:
		return std::string{ "Ccce" };
	case 69:
		return std::string{ "Fmmm" };
	case 70:
		return std::string{ "Fddd" };
	case 71:
		return std::string{ "Immm" };
	case 72:
		return std::string{ "Ibam" };
	case 73:
		return std::string{ "Ibca" };
	case 74:
		return std::string{ "Imma" };
	case 75:
		return std::string{ "P4" };
	case 76:
		return std::string{ "P4_1" };
	case 77:
		return std::string{ "P4_2" };
	case 78:
		return std::string{ "P4_3" };
	case 79:
		return std::string{ "I4" };
	case 80:
		return std::string{ "I4_1" };
	case 81:
		return std::string{ "P-4" };
	case 82:
		return std::string{ "I-4" };
	case 83:
		return std::string{ "P4/m" };
	case 84:
		return std::string{ "P4_2/m" };
	case 85:
		return std::string{ "P4/n" };
	case 86:
		return std::string{ "P4_2/n" };
	case 87:
		return std::string{ "I4/m" };
	case 88:
		return std::string{ "I4_1/a" };
	case 89:
		return std::string{ "P442" };
	case 90:
		return std::string{ "P42_12" };
	case 91:
		return std::string{ "P4_122" };
	case 92:
		return std::string{ "P4_12_12" };
	case 93:
		return std::string{ "P4_222" };
	case 94:
		return std::string{ "P4_22_12" };
	case 95:
		return std::string{ "P4_322" };
	case 96:
		return std::string{ "P4_32_12" };
	case 97:
		return std::string{ "I422" };
	case 98:
		return std::string{ "I4_122" };
	case 99:
		return std::string{ "P4mm" };
	case 100:
		return std::string{ "P4bm" };
	case 101:
		return std::string{ "P4_2cm" };
	case 102:
		return std::string{ "P4_2nm" };
	case 103:
		return std::string{ "P4cc" };
	case 104:
		return std::string{ "P4nc" };
	case 105:
		return std::string{ "P4_2mc" };
	case 106:
		return std::string{ "P4_2bc" };
	case 107:
		return std::string{ "I4mm" };
	case 108:
		return std::string{ "I4cm" };
	case 109:
		return std::string{ "I4_1md" };
	case 110:
		return std::string{ "I4_1cd" };
	case 111:
		return std::string{ "P42m" };
	case 112:
		return std::string{ "P-42c" };
	case 113:
		return std::string{ "P42_1m" };
	case 114:
		return std::string{ "P42_1c" };
	case 115:
		return std::string{ "P-4m2" };
	case 116:
		return std::string{ "P-4c2" };
	case 117:
		return std::string{ "P-4b2" };
	case 118:
		return std::string{ "P-4n2" };
	case 119:
		return std::string{ "I-4m2" };
	case 120:
		return std::string{ "I-4c2" };
	case 121:
		return std::string{ "I-42m" };
	case 122:
		return std::string{ "I-42d" };
	case 123:
		return std::string{ "P4/mmm" };
	case 124:
		return std::string{ "P4/mcc" };
	case 125:
		return std::string{ "P4/nbm" };
	case 126:
		return std::string{ "P4/nnc" };
	case 127:
		return std::string{ "P4/mbm" };
	case 128:
		return std::string{ "P4/mmc" };
	case 129:
		return std::string{ "P4/nmm" };
	case 130:
		return std::string{ "P4/ncc" };
	case 131:
		return std::string{ "P4_2/mmc" };
	case 132:
		return std::string{ "P4_2/mcm" };
	case 133:
		return std::string{ "P4_2/nbc" };
	case 134:
		return std::string{ "P4_2/nnm" };
	case 135:
		return std::string{ "P4_2/mbc" };
	case 136:
		return std::string{ "P4_2/mnm" };
	case 137:
		return std::string{ "P4_2/nmc" };
	case 138:
		return std::string{ "P4_2/ncm" };
	case 139:
		return std::string{ "I4/mmm" };
	case 140:
		return std::string{ "I4/mcm" };
	case 141:
		return std::string{ "I4_1/amd" };
	case 142:
		return std::string{ "I4_1/acd" };
	case 143:
		return std::string{ "P3" };
	case 144:
		return std::string{ "P3_1" };
	case 145:
		return std::string{ "P3_2" };
	case 146:
		return std::string{ "R3" };
	case 147:
		return std::string{ "P-3" };
	case 148:
		return std::string{ "R-3" };
	case 149:
		return std::string{ "P312" };
	case 150:
		return std::string{ "P321" };
	case 151:
		return std::string{ "P3_112" };
	case 152:
		return std::string{ "P3_121" };
	case 153:
		return std::string{ "P3_212" };
	case 154:
		return std::string{ "P3_221" };
	case 155:
		return std::string{ "R32" };
	case 156:
		return std::string{ "P3m1" };
	case 157:
		return std::string{ "P31m" };
	case 158:
		return std::string{ "P3c1" };
	case 159:
		return std::string{ "P31c" };
	case 160:
		return std::string{ "R3m" };
	case 161:
		return std::string{ "R3c" };
	case 162:
		return std::string{ "P-31m" };
	case 163:
		return std::string{ "P-31c" };
	case 164:
		return std::string{ "P-3m1" };
	case 165:
		return std::string{ "P-3c1" };
	case 166:
		return std::string{ "R-3m" };
	case 167:
		return std::string{ "R-3c" };
	case 168:
		return std::string{ "P6" };
	case 169:
		return std::string{ "P6_1" };
	case 170:
		return std::string{ "P6_5" };
	case 171:
		return std::string{ "P6_2" };
	case 172:
		return std::string{ "P6_4" };
	case 173:
		return std::string{ "P6_3" };
	case 174:
		return std::string{ "P-6" };
	case 175:
		return std::string{ "P6/m" };
	case 176:
		return std::string{ "P6_3/m" };
	case 177:
		return std::string{ "P622" };
	case 178:
		return std::string{ "P6_122" };
	case 179:
		return std::string{ "P6_522" };
	case 180:
		return std::string{ "P6_222" };
	case 181:
		return std::string{ "P6_422" };
	case 182:
		return std::string{ "P6_322" };
	case 183:
		return std::string{ "P6mm" };
	case 184:
		return std::string{ "P6cc" };
	case 185:
		return std::string{ "P6_3cm" };
	case 186:
		return std::string{ "P6_3mc" };
	case 187:
		return std::string{ "P-6m2" };
	case 188:
		return std::string{ "P-6c2" };
	case 189:
		return std::string{ "P-62m" };
	case 190:
		return std::string{ "P-62c" };
	case 191:
		return std::string{ "P6/mmm" };
	case 192:
		return std::string{ "P6/mcc" };
	case 193:
		return std::string{ "P6_3/mcm" };
	case 194:
		return std::string{ "P6_3/mmc" };
	case 195:
		return std::string{ "P23" };
	case 196:
		return std::string{ "F23" };
	case 197:
		return std::string{ "I23" };
	case 198:
		return std::string{ "P2_13" };
	case 199:
		return std::string{ "I2_13" };
	case 200:
		return std::string{ "Pm-3" };
	case 201:
		return std::string{ "Pn-3" };
	case 202:
		return std::string{ "Fm-3" };
	case 203:
		return std::string{ "Pd-3" };
	case 204:
		return std::string{ "Im-3" };
	case 205:
		return std::string{ "Pa-3" };
	case 206:
		return std::string{ "Ia-3" };
	case 207:
		return std::string{ "P432" };
	case 208:
		return std::string{ "P4_232" };
	case 209:
		return std::string{ "F432" };
	case 210:
		return std::string{ "F4_132" };
	case 211:
		return std::string{ "I432" };
	case 212:
		return std::string{ "P4_332" };
	case 213:
		return std::string{ "P4_132" };
	case 214:
		return std::string{ "I4_132" };
	case 215:
		return std::string{ "P-43m" };
	case 216:
		return std::string{ "F-43m" };
	case 217:
		return std::string{ "I-43m" };
	case 218:
		return std::string{ "P-43n" };
	case 219:
		return std::string{ "F-43c" };
	case 220:
		return std::string{ "I-43d" };
	case 221:
		return std::string{ "Pm-3m" };
	case 222:
		return std::string{ "Pn-3n" };
	case 223:
		return std::string{ "Pm-3n" };
	case 224:
		return std::string{ "Pn-3m" };
	case 225:
		return std::string{ "Fm-3m" };
	case 226:
		return std::string{ "Fm-3c" };
	case 227:
		return std::string{ "Fd-3m" };
	case 228:
		return std::string{ "Fd-3c" };
	case 229:
		return std::string{ "Im-3m" };
	case 230:
		return std::string{ "Ia-3d" };
	default:
		OperatingSystem::Configuration::ReportException reportException;
		throw std::invalid_argument(reportException("ChemToolkit::Crystallography::SpaceGroups::InternationalTables::setSpaceGroupNumber", "\"spaceGroupNumber\" is out of definitions."));
	}
}

// Public methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
