#include <iostream>

#include <mpi.h>

#include "MpiController.h"
#include "CrystalPrototypeDesigner.h"


int main(int argc, char* argv[])
{
	int mpiRank = 0;
	int mpiProcessing = 1;
	MPI_Init(&argc, &argv);
	MPI_Comm_size(MPI_COMM_WORLD, &mpiProcessing);
	MPI_Comm_rank(MPI_COMM_WORLD, &mpiRank);

	try
	{
		OperatingSystem::Configuration::MpiController::setMpiRank(static_cast<std::size_t>(mpiRank));
		OperatingSystem::Configuration::MpiController::setMpiProcessing(static_cast<std::size_t>(mpiProcessing));

		OperatingSystem::SystemManagement::CrystalPrototypeDesigner crystalPrototypeDesigner(argc, argv);
		crystalPrototypeDesigner.execute();
	}

	catch (const std::exception& e)
	{
		std::cerr << "Exception: ";
		std::cerr << e.what() << "\n";
		std::cerr << "Terminate this program.\n\n";
	}


	std::cout << "MPI " << mpiRank << ": Finalize" << std::endl;
	MPI_Finalize();

	return 0;
}
