#include "MdFileWriter.h"

using namespace OpenMX::FileIO;

// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Constructors

MdFileWriter::MdFileWriter(const std::filesystem::path& mdFilePath)
	: FileWriter{ mdFilePath }
{
	if (!(isCorrectExtension(filePath())))
	{
		std::string errorMessage;
		{
			errorMessage += "The extension of mdFilePath, which is \"";
			errorMessage += filePath().generic_string();
			errorMessage += "\", is not \"";
			errorMessage += correctExtension();
			errorMessage += "\".";
		}

		OperatingSystem::Configuration::ReportException reportException;
		throw std::invalid_argument(reportException(typeid(*this), "constructor", errorMessage));
	}
}

MdFileWriter::MdFileWriter(std::filesystem::path&& mdFilePath)
	: FileWriter{ std::move(mdFilePath) }
{
	if (!(isCorrectExtension(filePath())))
	{
		std::string errorMessage;
		{
			errorMessage += "The extension of mdFilePath, which is \"";
			errorMessage += filePath().generic_string();
			errorMessage += "\", is not \"";
			errorMessage += correctExtension();
			errorMessage += "\".";
		}

		OperatingSystem::Configuration::ReportException reportException;
		throw std::invalid_argument(reportException(typeid(*this), "constructor", errorMessage));
	}
}

// Constructors
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
