#include "MinimumDistanceConstraint.h"

using namespace MathematicalCrystalChemistry::StructureModel::GeometricalConstraints::Internal;


// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Protected constructors

MinimumDistanceConstraint::MinimumDistanceConstraint(ModelAtom& modelAtom, const Ligand& ligand)
	: InteratomicConstraintBase{ modelAtom, ligand }
	, m_minimumDistance{ 0.0 }
{
}

MinimumDistanceConstraint::MinimumDistanceConstraint(ModelAtom& modelAtom, Ligand&& ligand)
	: InteratomicConstraintBase{ modelAtom, std::move(ligand) }
	, m_minimumDistance{ 0.0 }
{
}

MinimumDistanceConstraint::MinimumDistanceConstraint(const Ligand& la, const Ligand& lb)
	: InteratomicConstraintBase{ la, lb }
	, m_minimumDistance{ 0.0 }
{
}

MinimumDistanceConstraint::MinimumDistanceConstraint(const std::shared_ptr<MinimumDistanceConstraint>& reversePtr)
	: InteratomicConstraintBase{ std::dynamic_pointer_cast<InteratomicConstraintBase>(reversePtr) }
	, m_minimumDistance{ reversePtr->m_minimumDistance }
{
}

// Protected constructors
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
