#include "ModelChemicalElement.h"

using namespace MathematicalCrystalChemistry::StructureModel::ChemicalElements;


// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Constructor

ModelChemicalElement::ModelChemicalElement(const std::string& elementSymbol)
	: m_elementSymbol{ elementSymbol }
	, m_atomCategory{ elementSymbol }
	, m_feasibleCoordinationFeatures{}
	, m_oxidationFeature{ elementSymbol }
{
	for (const auto& oxidationState : m_oxidationFeature.feasibleOxidationStates())
	{
		std::vector<CoordinationFeature> coordinationFeatures;

		for (const auto& coordinationFeatureSymbol : getFeasibleCoordinationFeatureSymbols(elementSymbol, oxidationState))
			coordinationFeatures.push_back(CoordinationFeature{ coordinationFeatureSymbol });

		m_feasibleCoordinationFeatures.emplace(oxidationState, std::move(coordinationFeatures));
	}		
}

// Constructor
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Static methods

std::vector<MathematicalCrystalChemistry::StructureModel::Features::CoordinationFeatureSymbol> ModelChemicalElement::getFeasibleCoordinationFeatureSymbols(std::string elementSymbol, const size_type oxidationState)
{
	std::vector<CoordinationFeatureSymbol> feasibleCoordinationFeatureSymbols;


	return feasibleCoordinationFeatureSymbols;
}

// Static methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
