#include "NumericalMatrix.h"

#include <memory>

#include <mkl.h>

using namespace MathToolkit::Generic;


// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Mathematical methods

template <>
NumericalMatrix<double>& NumericalMatrix<double>::invert()
{
	if (isSquareMatrix())
	{
		NumericalMatrix<double> inverseMatrix = getIdentityMatrix<double>(columnSize());
		std::unique_ptr<lapack_int[]> ipiv{ new lapack_int[columnSize()] };
		const lapack_int n = static_cast<lapack_int>(columnSize());
		{
			lapack_int info = LAPACKE_dgesv(LAPACK_COL_MAJOR, n, n, begin(), n, ipiv.get(), inverseMatrix.begin(), n);

			if (info != 0)
			{
				OperatingSystem::Configuration::ReportException reportException;
				throw std::runtime_error(reportException(typeid(*this), "invert", "Could not find inverse matrix."));
			}
		}

		this->swap(inverseMatrix);
		return *this;
	}

	else
	{
		OperatingSystem::Configuration::ReportException reportException;
		throw std::runtime_error(reportException(typeid(*this), "invert", "This is not a square matrix."));
	}
}

template <>
void NumericalMatrix<double>::getSingularValueDecomposition() const
{
}

// Mathematical methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
