#include "NumericalVectorSlice.h"

using namespace MathToolkit::Generic;


// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Constructors

template <>
NumericalVectorSlice<double>::NumericalVectorSlice(std::valarray<value_type>& va, const std::slice& sl)
	: m_valueArraySlice{ va }
	, m_start{ sl.start() }
	, m_size{ sl.size() }
	, m_stride{ sl.stride() }
{
	if (m_size == 0)
	{
		OperatingSystem::Configuration::ReportException reportException;
		throw std::invalid_argument(reportException(typeid(*this), "constructor", "size is zero."));
	}

	if (m_stride == 0)
	{
		OperatingSystem::Configuration::ReportException reportException;
		throw std::invalid_argument(reportException(typeid(*this), "constructor", "stride is zero."));
	}

	if (va.size() <= (m_start + ((m_size - 1) * m_stride)))
	{
		OperatingSystem::Configuration::ReportException reportException;
		throw std::invalid_argument(reportException(typeid(*this), "constructor", "Range of the slice is invalid."));
	}
}

template <>
NumericalVectorSlice<std::complex<double>>::NumericalVectorSlice(std::valarray<value_type>& va, const std::slice& sl)
	: m_valueArraySlice{ va }
	, m_start{ sl.start() }
	, m_size{ sl.size() }
	, m_stride{ sl.stride() }
{
	if (m_size == 0)
	{
		OperatingSystem::Configuration::ReportException reportException;
		throw std::invalid_argument(reportException(typeid(*this), "constructor", "size is zero."));
	}

	if (m_stride == 0)
	{
		OperatingSystem::Configuration::ReportException reportException;
		throw std::invalid_argument(reportException(typeid(*this), "constructor", "stride is zero."));
	}

	if (va.size() <= (m_start + ((m_size - 1) * m_stride)))
	{
		OperatingSystem::Configuration::ReportException reportException;
		throw std::invalid_argument(reportException(typeid(*this), "constructor", "Range of the slice is invalid."));
	}
}

// Constructors
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
