#include "PeriodicTable.h"

#include "LengthCasting.h"

using namespace ChemToolkit::Generic;

// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Public methods

double PeriodicTable::getAtomicRadius(const std::string& elementSymbol)
{
	using MathToolkit::UnitConversion::LengthCasting::Unit::AtomicUnit;
	using Picometre = MathToolkit::UnitConversion::LengthCasting::Unit::Metre<std::pico>;

	return 0.0;		
}

double PeriodicTable::getMetallicRadius(const std::string& elementSymbol)
{
	using MathToolkit::UnitConversion::LengthCasting::Unit::AtomicUnit;
	using Picometre = MathToolkit::UnitConversion::LengthCasting::Unit::Metre<std::pico>;

	if (elementSymbol == "Li")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(152.0);
	if (elementSymbol == "Be")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(112.0);
	if (elementSymbol == "Na")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(186.0);
	if (elementSymbol == "Mg")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(160.0);
	if (elementSymbol == "Al")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(143.0);
	if (elementSymbol == "K")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(230.0);
	if (elementSymbol == "Ca")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(197.0);
	if (elementSymbol == "Sc")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(162.0);
	if (elementSymbol == "Ti")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(146.0);
	if (elementSymbol == "V")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(134.0);
	if (elementSymbol == "Cr")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(128.0);
	if (elementSymbol == "Mn")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(137.0);
	if (elementSymbol == "Fe")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(126.0);
	if (elementSymbol == "Co")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(125.0);
	if (elementSymbol == "Ni")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(125.0);
	if (elementSymbol == "Cu")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(128.0);
	if (elementSymbol == "Zn")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(134.0);
	if (elementSymbol == "Ga")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(135.0);
	if (elementSymbol == "Rb")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(247.0);
	if (elementSymbol == "Sr")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(215.0);
	if (elementSymbol == "Y")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(180.0);
	if (elementSymbol == "Zr")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(160.0);
	if (elementSymbol == "Nb")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(146.0);
	if (elementSymbol == "Mo")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(139.0);
	if (elementSymbol == "Ru")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(134.0);
	if (elementSymbol == "Rh")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(134.0);
	if (elementSymbol == "Pd")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(137.0);
	if (elementSymbol == "Ag")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(144.0);
	if (elementSymbol == "Cd")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(151.0);
	if (elementSymbol == "In")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(167.0);
	if (elementSymbol == "Sn")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(154.0);
	if (elementSymbol == "Cs")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(267.0);
	if (elementSymbol == "Ba")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(222.0);
	if (elementSymbol == "La")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(187.0);
	if (elementSymbol == "Ce")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(182.0);
	if (elementSymbol == "Pr")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(182.0);
	if (elementSymbol == "Nd")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(182.0);
	if (elementSymbol == "Pm")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(181.0);
	if (elementSymbol == "Sm")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(180.0);
	if (elementSymbol == "Eu")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(204.0);
	if (elementSymbol == "Gd")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(179.0);
	if (elementSymbol == "Tb")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(178.0);
	if (elementSymbol == "Dy")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(177.0);
	if (elementSymbol == "Ho")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(176.0);
	if (elementSymbol == "Er")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(175.0);
	if (elementSymbol == "Tm")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(174.0);
	if (elementSymbol == "Yb")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(193.0);
	if (elementSymbol == "Lu")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(174.0);
	if (elementSymbol == "Hf")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(158.0);
	if (elementSymbol == "Ta")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(146.0);
	if (elementSymbol == "W")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(139.0);
	if (elementSymbol == "Re")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(137.0);
	if (elementSymbol == "Os")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(135.0);
	if (elementSymbol == "Ir")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(136.0);
	if (elementSymbol == "Pt")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(139.0);
	if (elementSymbol == "Au")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(144.0);
	if (elementSymbol == "Hg")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(151.0);
	if (elementSymbol == "Tl")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(171.0);
	if (elementSymbol == "Pb")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(175.0);
	if (elementSymbol == "Bi")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(178.0);
	if (elementSymbol == "Po")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(80.5);
	if (elementSymbol == "Ac")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(190.0);
	if (elementSymbol == "Th")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(180.0);
	if (elementSymbol == "Pa")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(161.0);
	if (elementSymbol == "U")
		return MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(156.0);
	else
		return 0.0;
}

std::map<int, double> PeriodicTable::getIonicRadii(const std::string& elementSymbol)
{
	std::map<int, double> ionicRadii;

	using MathToolkit::UnitConversion::LengthCasting::Unit::AtomicUnit;
	using Picometre = MathToolkit::UnitConversion::LengthCasting::Unit::Metre<std::pico>;

	if (elementSymbol == "H")
	{
		ionicRadii.emplace(-1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(150.0));
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(0.0));
	}
	if (elementSymbol == "Li")
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(76.0));
	if (elementSymbol == "Be")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(45.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(45.0));
	}
	if (elementSymbol == "B")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(27.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(27.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(27.0));
	}
	if (elementSymbol == "C")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(16.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(16.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(16.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(16.0));
	}
	if (elementSymbol == "N")
	{
		ionicRadii.emplace(-1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(146.0));
		ionicRadii.emplace(-2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(146.0));
		ionicRadii.emplace(-3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(146.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(16.0));
	}
	if (elementSymbol == "O")
		ionicRadii.emplace(-1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(140.0));
		ionicRadii.emplace(-2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(140.0));
	if (elementSymbol == "F")
		ionicRadii.emplace(-1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(133.0));
	if (elementSymbol == "Na")
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(102.0));
	if (elementSymbol == "Mg")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(72.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(72.0));
	}
	if (elementSymbol == "Al")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(54.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(54.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(54.0));
	}
	if (elementSymbol == "Si")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(40.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(40.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(40.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(40.0));
	}
	if (elementSymbol == "P")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(44.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(44.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(44.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(38.0));
		ionicRadii.emplace(5, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(38.0));
	}
	if (elementSymbol == "S")
	{
		ionicRadii.emplace(-1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(184.0));
		ionicRadii.emplace(-2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(184.0));
		ionicRadii.emplace(6, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(29.0));
	}
	if (elementSymbol == "Cl")
		ionicRadii.emplace(-1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(181.0));
	if (elementSymbol == "K")
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(138.0));
	if (elementSymbol == "Ca")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(100.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(100.0));
	}
	if (elementSymbol == "Sc")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(75.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(75.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(75.0));
	}
	if (elementSymbol == "Ti")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(86.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(86.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(67.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(61.0));
	}
	if (elementSymbol == "V")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(79.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(79.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(64.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(58.0));
		ionicRadii.emplace(5, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(54.0));
	}
	if (elementSymbol == "Cr")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(80.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(80.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(62.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(55.0));
		ionicRadii.emplace(5, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(49.0));
		ionicRadii.emplace(6, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(44.0));
	}
	if (elementSymbol == "Mn")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(83.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(83.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(65.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(53.0));
		ionicRadii.emplace(5, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(26.0));
		ionicRadii.emplace(6, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(25.0));
	}
	if (elementSymbol == "Fe")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(78.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(78.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(65.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(59.0));
		ionicRadii.emplace(5, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(25.0));
		ionicRadii.emplace(6, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(25.0));
	}
	if (elementSymbol == "Co")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(75.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(75.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(61.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(53.0));
	}
	if (elementSymbol == "Ni")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(69.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(69.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(60.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(48.0));
	}
	if (elementSymbol == "Cu")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(77.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(73.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(54.0));
	}
	if (elementSymbol == "Zn")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(74.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(74.0));
	}
	if (elementSymbol == "Ga")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(62.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(62.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(62.0));
	}
	if (elementSymbol == "Ge")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(73.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(73.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(53.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(53.0));
	}
	if (elementSymbol == "As")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(58.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(58.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(58.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(46.0));
		ionicRadii.emplace(5, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(46.0));
	}
	if (elementSymbol == "Se")
	{
		ionicRadii.emplace(-1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(198.0));
		ionicRadii.emplace(-2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(198.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(50.0));
	}
	if (elementSymbol == "Br")
		ionicRadii.emplace(-1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(196.0));
	if (elementSymbol == "Rb")
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(152.0));
	if (elementSymbol == "Sr")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(118.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(118.0));
	}
	if (elementSymbol == "Y")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(90.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(90.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(90.0));
	}
	if (elementSymbol == "Zr")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(72.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(72.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(72.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(72.0));
	}
	if (elementSymbol == "Nb")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(72.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(72.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(72.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(68.0));
		ionicRadii.emplace(5, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(64.0));
	}
	if (elementSymbol == "Mo")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(69.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(69.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(69.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(65.0));
		ionicRadii.emplace(5, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(61.0));
		ionicRadii.emplace(6, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(59.0));
	}
	if (elementSymbol == "Ru")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(68.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(68.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(68.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(62.0));
		ionicRadii.emplace(5, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(57.0));
	}
	if (elementSymbol == "Rh")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(67.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(67.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(67.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(60.0));
		ionicRadii.emplace(5, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(55.0));
	}
	if (elementSymbol == "Pd")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(86.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(86.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(76.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(62.0));
	}
	if (elementSymbol == "Ag")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(115.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(94.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(75.0));
	}
	if (elementSymbol == "Cd")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(95.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(95.0));
	}
	if (elementSymbol == "In")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(80.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(80.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(80.0));
	}
	if (elementSymbol == "Sn")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(118.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(118.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(69.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(69.0));
	}
	if (elementSymbol == "Sb")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(76.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(76.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(76.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(60.0));
		ionicRadii.emplace(5, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(60.0));
	}
	if (elementSymbol == "Te")
	{
		ionicRadii.emplace(-1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(221.0));
		ionicRadii.emplace(-2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(221.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(97.0));
		ionicRadii.emplace(6, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(56.0));
	}
	if (elementSymbol == "I")
	{
		ionicRadii.emplace(-1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(220.0));
		ionicRadii.emplace(5, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(95.0));
		ionicRadii.emplace(7, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(53.0));
	}
	if (elementSymbol == "Cs")
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(167.0));
	if (elementSymbol == "Ba")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(135.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(135.0));
	}
	if (elementSymbol == "La")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(103.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(103.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(103.0));
	}
	if (elementSymbol == "Ce")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(101.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(101.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(101.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(87.0));
	}
	if (elementSymbol == "Pr")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(99.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(99.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(99.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(85.0));
	}
	if (elementSymbol == "Nd")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(98.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(98.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(98.0));
	}
	if (elementSymbol == "Pm")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(97.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(97.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(97.0));
	}
	if (elementSymbol == "Sm")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(96.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(96.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(96.0));
	}
	if (elementSymbol == "Eu")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(117.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(117.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(95.0));
	}
	if (elementSymbol == "Gd")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(94.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(94.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(94.0));
	}
	if (elementSymbol == "Tb")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(92.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(92.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(92.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(76.0));
	}
	if (elementSymbol == "Dy")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(107.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(107.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(91.0));
	}
	if (elementSymbol == "Ho")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(90.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(90.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(90.0));
	}
	if (elementSymbol == "Er")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(89.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(89.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(89.0));
	}
	if (elementSymbol == "Tm")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(103.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(103.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(88.0));
	}
	if (elementSymbol == "Yb")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(102.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(102.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(87.0));
	}
	if (elementSymbol == "Lu")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(86.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(86.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(86.0));
	}
	if (elementSymbol == "Hf")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(71.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(71.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(71.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(71.0));
	}
	if (elementSymbol == "Ta")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(72.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(72.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(72.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(68.0));
		ionicRadii.emplace(5, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(64.0));
	}
	if (elementSymbol == "W")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(66.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(66.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(66.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(66.0));
		ionicRadii.emplace(5, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(62.0));
		ionicRadii.emplace(6, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(60.0));
	}
	if (elementSymbol == "Re")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(63.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(63.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(63.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(63.0));
		ionicRadii.emplace(5, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(58.0));
		ionicRadii.emplace(6, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(55.0));
	}
	if (elementSymbol == "Os")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(63.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(63.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(63.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(63.0));
		ionicRadii.emplace(5, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(58.0));
		ionicRadii.emplace(6, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(55.0));
	}
	if (elementSymbol == "Ir")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(68.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(68.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(68.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(63.0));
		ionicRadii.emplace(5, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(57.0));
	}
	if (elementSymbol == "Pt")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(80.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(80.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(63.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(63.0));
		ionicRadii.emplace(5, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(57.0));
	}
	if (elementSymbol == "Au")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(137.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(85.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(85.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(57.0));
		ionicRadii.emplace(5, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(57.0));
	}
	if (elementSymbol == "Hg")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(119.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(102.0));
	}
	if (elementSymbol == "Tl")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(150.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(89.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(89.0));
	}
	if (elementSymbol == "Pb")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(119.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(119.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(78.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(78.0));
	}
	if (elementSymbol == "Bi")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(103.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(103.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(103.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(76.0));
		ionicRadii.emplace(5, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(76.0));
	}
	if (elementSymbol == "Ac")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(112.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(112.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(112.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(112.0));
	}
	if (elementSymbol == "Th")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(94.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(94.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(94.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(94.0));
	}
	if (elementSymbol == "Pa")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(104.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(104.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(104.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(90.0));
		ionicRadii.emplace(5, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(78.0));
	}
	if (elementSymbol == "U")
	{
		ionicRadii.emplace(1, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(103.0));
		ionicRadii.emplace(2, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(103.0));
		ionicRadii.emplace(3, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(103.0));
		ionicRadii.emplace(4, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(89.0));
		ionicRadii.emplace(5, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(76.0));
		ionicRadii.emplace(6, MathToolkit::UnitConversion::LengthCasting::cast<Picometre, AtomicUnit>(73.0));
	}

	return ionicRadii;
}

// Public methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Private methods

std::string PeriodicTable::translateIntoElementSymbol(const size_type atomicNumber)
{
	switch (atomicNumber)
	{
	case 1:
		return "H";
	case 2:
		return "He";
	case 3:
		return "Li";
	case 4:
		return "Be";
	case 5:
		return "B";
	case 6:
		return "C";
	case 7:
		return "N";
	case 8:
		return "O";
	case 9:
		return "F";
	case 10:
		return "Ne";
	case 11:
		return "Na";
	case 12:
		return "Mg";
	case 13:
		return "Al";
	case 14:
		return "Si";
	case 15:
		return "P";
	case 16:
		return "S";
	case 17:
		return "Cl";
	case 18:
		return "Ar";
	case 19:
		return "K";
	case 20:
		return "Ca";
	case 21:
		return "Sc";
	case 22:
		return "Ti";
	case 23:
		return "V";
	case 24:
		return "Cr";
	case 25:
		return "Mn";
	case 26:
		return "Fe";
	case 27:
		return "Co";
	case 28:
		return "Ni";
	case 29:
		return "Cu";
	case 30:
		return "Zn";
	case 31:
		return "Ga";
	case 32:
		return "Ge";
	case 33:
		return "As";
	case 34:
		return "Se";
	case 35:
		return "Br";
	case 36:
		return "Kr";
	case 37:
		return "Rb";
	case 38:
		return "Sr";
	case 39:
		return "Y";
	case 40:
		return "Zr";
	case 41:
		return "Nb";
	case 42:
		return "Mo";
	case 43:
		return "Tc";
	case 44:
		return "Ru";
	case 45:
		return "Rh";
	case 46:
		return "Pd";
	case 47:
		return "Ag";
	case 48:
		return "Cd";
	case 49:
		return "In";
	case 50:
		return "Sn";
	case 51:
		return "Sb";
	case 52:
		return "Te";
	case 53:
		return "I";
	case 54:
		return "Xe";
	case 55:
		return "Cs";
	case 56:
		return "Ba";
	case 57:
		return "La";
	case 58:
		return "Ce";
	case 59:
		return "Pr";
	case 60:
		return "Nd";
	case 61:
		return "Pm";
	case 62:
		return "Sm";
	case 63:
		return "Eu";
	case 64:
		return "Gd";
	case 65:
		return "Tb";
	case 66:
		return "Dy";
	case 67:
		return "Ho";
	case 68:
		return "Er";
	case 69:
		return "Tm";
	case 70:
		return "Yb";
	case 71:
		return "Lu";
	case 72:
		return "Hf";
	case 73:
		return "Ta";
	case 74:
		return "W";
	case 75:
		return "Re";
	case 76:
		return "Os";
	case 77:
		return "Ir";
	case 78:
		return "Pt";
	case 79:
		return "Au";
	case 80:
		return "Hg";
	case 81:
		return "Tl";
	case 82:
		return "Pb";
	case 83:
		return "Bi";
	case 84:
		return "Po";
	case 85:
		return "At";
	case 86:
		return "Rn";
	case 87:
		return "Fr";
	case 88:
		return "Ra";
	case 89:
		return "Ac";
	case 90:
		return "Th";
	case 91:
		return "Pa";
	case 92:
		return "U";
	default:
		return std::string{};
	}
}

std::size_t PeriodicTable::translateIntoAtomicNumber(const std::string& elementSymbol)
{
	if (elementSymbol == "H")
		return 1;
	if (elementSymbol == "He")
		return 2;
	if (elementSymbol == "Li")
		return 3;
	if (elementSymbol == "Be")
		return 4;
	if (elementSymbol == "B")
		return 5;
	if (elementSymbol == "C")
		return 6;
	if (elementSymbol == "N")
		return 7;
	if (elementSymbol == "O")
		return 8;
	if (elementSymbol == "F")
		return 9;
	if (elementSymbol == "Ne")
		return 10;
	if (elementSymbol == "Na")
		return 11;
	if (elementSymbol == "Mg")
		return 12;
	if (elementSymbol == "Al")
		return 13;
	if (elementSymbol == "Si")
		return 14;
	if (elementSymbol == "P")
		return 15;
	if (elementSymbol == "S")
		return 16;
	if (elementSymbol == "Cl")
		return 17;
	if (elementSymbol == "Ar")
		return 18;
	if (elementSymbol == "K")
		return 19;
	if (elementSymbol == "Ca")
		return 20;
	if (elementSymbol == "Sc")
		return 21;
	if (elementSymbol == "Ti")
		return 22;
	if (elementSymbol == "V")
		return 23;
	if (elementSymbol == "Cr")
		return 24;
	if (elementSymbol == "Mn")
		return 25;
	if (elementSymbol == "Fe")
		return 26;
	if (elementSymbol == "Co")
		return 27;
	if (elementSymbol == "Ni")
		return 28;
	if (elementSymbol == "Cu")
		return 29;
	if (elementSymbol == "Zn")
		return 30;
	if (elementSymbol == "Ga")
		return 31;
	if (elementSymbol == "Ge")
		return 32;
	if (elementSymbol == "As")
		return 33;
	if (elementSymbol == "Se")
		return 34;
	if (elementSymbol == "Br")
		return 35;
	if (elementSymbol == "Kr")
		return 36;
	if (elementSymbol == "Rb")
		return 37;
	if (elementSymbol == "Sr")
		return 38;
	if (elementSymbol == "Y")
		return 39;
	if (elementSymbol == "Zr")
		return 40;
	if (elementSymbol == "Nb")
		return 41;
	if (elementSymbol == "Mo")
		return 42;
	if (elementSymbol == "Tc")
		return 43;
	if (elementSymbol == "Ru")
		return 44;
	if (elementSymbol == "Rh")
		return 45;
	if (elementSymbol == "Pd")
		return 46;
	if (elementSymbol == "Ag")
		return 47;
	if (elementSymbol == "Cd")
		return 48;
	if (elementSymbol == "In")
		return 49;
	if (elementSymbol == "Sn")
		return 50;
	if (elementSymbol == "Sb")
		return 51;
	if (elementSymbol == "Te")
		return 52;
	if (elementSymbol == "I")
		return 53;
	if (elementSymbol == "Xe")
		return 54;
	if (elementSymbol == "Cs")
		return 55;
	if (elementSymbol == "Ba")
		return 56;
	if (elementSymbol == "La")
		return 57;
	if (elementSymbol == "Ce")
		return 58;
	if (elementSymbol == "Pr")
		return 59;
	if (elementSymbol == "Nd")
		return 60;
	if (elementSymbol == "Pm")
		return 61;
	if (elementSymbol == "Sm")
		return 62;
	if (elementSymbol == "Eu")
		return 63;
	if (elementSymbol == "Gd")
		return 64;
	if (elementSymbol == "Tb")
		return 65;
	if (elementSymbol == "Dy")
		return 66;
	if (elementSymbol == "Ho")
		return 67;
	if (elementSymbol == "Er")
		return 68;
	if (elementSymbol == "Tm")
		return 69;
	if (elementSymbol == "Yb")
		return 70;
	if (elementSymbol == "Lu")
		return 71;
	if (elementSymbol == "Hf")
		return 72;
	if (elementSymbol == "Ta")
		return 73;
	if (elementSymbol == "W")
		return 74;
	if (elementSymbol == "Re")
		return 75;
	if (elementSymbol == "Os")
		return 76;
	if (elementSymbol == "Ir")
		return 77;
	if (elementSymbol == "Pt")
		return 78;
	if (elementSymbol == "Au")
		return 79;
	if (elementSymbol == "Hg")
		return 80;
	if (elementSymbol == "Tl")
		return 81;
	if (elementSymbol == "Pb")
		return 82;
	if (elementSymbol == "Bi")
		return 83;
	if (elementSymbol == "Po")
		return 84;
	if (elementSymbol == "At")
		return 85;
	if (elementSymbol == "Rn")
		return 86;
	if (elementSymbol == "Fr")
		return 87;
	if (elementSymbol == "Ra")
		return 88;
	if (elementSymbol == "Ac")
		return 89;
	if (elementSymbol == "Th")
		return 90;
	if (elementSymbol == "Pa")
		return 91;
	if (elementSymbol == "U")
		return 92;
	else
		return 0;
}

// Private methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
