#include "RandomStructureGenerator.h"

#include <random>

#include "LinearAlgebra.h"
#include "MathematicalConstants.h"

using namespace MathematicalCrystalChemistry::Design::Generation::Internal;


// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Constructors

RandomStructureGenerator::RandomStructureGenerator()
	: m_randomValueGenerator{}
	, m_randomStructureGenerationParameters{}
{
}

RandomStructureGenerator::RandomStructureGenerator(const RandomStructureGenerationParameters& randomStructureGenerationParameters)
	: m_randomValueGenerator{}
	, m_randomStructureGenerationParameters{ randomStructureGenerationParameters }
{
}

// Constructors
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Private methods

ChemToolkit::Crystallography::UnitCell RandomStructureGenerator::generateUnitCell() const
{
	ChemToolkit::Crystallography::LatticeParameters latticeParameters;
	{
		latticeParameters.lengths.a = 1.0;
		latticeParameters.lengths.b = m_randomValueGenerator.getUniformDistributedValue(1.0, m_randomStructureGenerationParameters.maxInitialLatticeLengthRatio());
		latticeParameters.lengths.c = m_randomValueGenerator.getUniformDistributedValue(1.0, m_randomStructureGenerationParameters.maxInitialLatticeLengthRatio());

		latticeParameters.angles.alpha = m_randomValueGenerator.getUniformDistributedValue(m_randomStructureGenerationParameters.minInitialLatticeAngle(), m_randomStructureGenerationParameters.maxInitialLatticeAngle());
		latticeParameters.angles.beta = m_randomValueGenerator.getUniformDistributedValue(m_randomStructureGenerationParameters.minInitialLatticeAngle(), m_randomStructureGenerationParameters.maxInitialLatticeAngle());
		latticeParameters.angles.gamma = m_randomValueGenerator.getUniformDistributedValue(m_randomStructureGenerationParameters.minInitialLatticeAngle(), m_randomStructureGenerationParameters.maxInitialLatticeAngle());
	}

	return ChemToolkit::Crystallography::UnitCell{ latticeParameters };
}

// Private methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
