#include "RandomValueGenerator.h"

using namespace MathToolkit::Numerics;


// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Constructors

std::size_t RandomValueGenerator::m_defaultMaxRandomValueGenerating{ 1000 };


RandomValueGenerator::RandomValueGenerator()
	: m_maxRandomValueGenerating{ m_defaultMaxRandomValueGenerating }
	, m_seedGenerator{}
{
	m_engine = std::default_random_engine(m_seedGenerator());
	m_distributor = std::uniform_real_distribution<>(0.0, 1.0);
	m_randomValueGenerating = 0;
}

RandomValueGenerator::RandomValueGenerator(const RandomValueGenerator& randomValueGenerator)
	: m_maxRandomValueGenerating{ randomValueGenerator.m_maxRandomValueGenerating }
	, m_seedGenerator{}
{
	m_engine = std::default_random_engine(m_seedGenerator());
	m_distributor = std::uniform_real_distribution<>(0.0, 1.0);
	m_randomValueGenerating = 0;
}

RandomValueGenerator::RandomValueGenerator(RandomValueGenerator&& randomValueGenerator) noexcept
	: m_maxRandomValueGenerating{ randomValueGenerator.m_maxRandomValueGenerating }
	, m_seedGenerator{}
{
	m_engine = std::default_random_engine(m_seedGenerator());
	m_distributor = std::uniform_real_distribution<>(0.0, 1.0);
	m_randomValueGenerating = 0;
}

RandomValueGenerator& RandomValueGenerator::operator=(const RandomValueGenerator& randomValueGenerator)
{
	m_maxRandomValueGenerating = randomValueGenerator.m_maxRandomValueGenerating;
	m_engine = std::default_random_engine(m_seedGenerator());
	m_distributor = std::uniform_real_distribution<>(0.0, 1.0);
	m_randomValueGenerating = 0;

	return *this;
}

RandomValueGenerator& RandomValueGenerator::operator=(RandomValueGenerator&& randomValueGenerator) noexcept
{
	m_maxRandomValueGenerating = randomValueGenerator.m_maxRandomValueGenerating;
	m_engine = std::default_random_engine(m_seedGenerator());
	m_distributor = std::uniform_real_distribution<>(0.0, 1.0);
	m_randomValueGenerating = 0;

	return *this;
}

// Constructors
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
