#include "StructureCreationReportOptions.h"

#include "FileReader.h"

using namespace MathematicalCrystalChemistry::Runtime::Creation;


// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Constructor

StructureCreationReportOptions::StructureCreationReportOptions()
	: m_workDirectoryPath{}
	, m_designedStructuresDirectoryPath{}
	, m_needInfeasibleStructureData{ false }
	, m_structureDesignRecordOptions{}
{
}

// Constructor
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Public methods

void StructureCreationReportOptions::initialize()
{
	m_workDirectoryPath.clear();
	m_designedStructuresDirectoryPath.clear();
	m_needInfeasibleStructureData = false;

	m_structureDesignRecordOptions.initialize();
}

void StructureCreationReportOptions::initializeFromInputFileTexts(const std::string& inputTexts)
{
	using OperatingSystem::IO::FileReader;
	{
		std::string directoryPathName;
		FileReader::tryReadData(inputTexts, "Work.Directory.Path", directoryPathName);
		m_workDirectoryPath = std::filesystem::path{ directoryPathName };
	}
	{
		std::string directoryPathName;
		FileReader::tryReadData(inputTexts, "Designed.Structures.Directory.Path", directoryPathName);
		m_designedStructuresDirectoryPath = std::filesystem::path{ directoryPathName };
	}
	{
		std::string flag;
		FileReader::tryReadData(inputTexts, "Report.Infeasible.Structure", flag);
		m_needInfeasibleStructureData = translateIntoBool(flag);
	}

	m_structureDesignRecordOptions.initializeFromInputFileTexts(inputTexts);
}

// Public methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
