#include "StructureDesignRecordOptions.h"

#include "FileReader.h"

using namespace MathematicalCrystalChemistry::Design::Recording;


// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Constructor

StructureDesignRecordOptions::StructureDesignRecordOptions()
	: m_mdRecordFrequency{ 0 }
	, m_chemicalBondsRecordFrequency{ 0 }
{
}

// Constructor
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Public methods

void StructureDesignRecordOptions::initialize()
{
	m_mdRecordFrequency = 0;
	m_chemicalBondsRecordFrequency = 0;

}

void StructureDesignRecordOptions::initializeFromInputFileTexts(const std::string& inputTexts)
{
	using OperatingSystem::IO::FileReader;

	FileReader::tryReadData(inputTexts, "MD.Record.Frequency", m_mdRecordFrequency);
	FileReader::tryReadData(inputTexts, "Chemical.Bonds.Record.Frequency", m_chemicalBondsRecordFrequency);
}

// Public methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
