#include "StructureReporter.h"

#include "FileWriter.h"

using namespace MathematicalCrystalChemistry::IO;


// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Static member

std::string StructureReporter::m_filename{ "structure_report.txt" };


// Static member
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Public methods

void StructureReporter::report(const ModelCrystalStructure& modelCrystalStructure, const std::filesystem::path& outputDirectoryPath) const
{
	std::string outputText;

	for (const auto& modelAtom : modelCrystalStructure.atomicArrangement())
	{
		outputText += modelAtom.elementSymbol();
		outputText += "   ";
		outputText += modelAtom.coordinationFeature().atomCategory().symbol();
		outputText += "   ";
		outputText += modelAtom.getChemicalBondComposition().name();
		outputText += "   ";
		outputText += modelAtom.siteSymmetrySymbol();
		outputText += "   ";
		outputText += std::to_string(modelAtom.coordinate()[0]);
		outputText += "   ";
		outputText += std::to_string(modelAtom.coordinate()[1]);
		outputText += "   ";
		outputText += std::to_string(modelAtom.coordinate()[2]);
		outputText += "\n";
	}


	std::filesystem::path filePath = outputDirectoryPath;
	filePath /= m_filename;
	OperatingSystem::IO::FileWriter fileWriter{ filePath };
	fileWriter.createFile(OperatingSystem::IO::FileCreateOptions::skip_existing, outputText);
}

// Public methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Private methods


// Private methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
