#include "WholeStructuralConstraints.h"

#include "FileReader.h"
#include "PeriodicTable.h"

using namespace MathematicalCrystalChemistry::Analysis;


// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Constructor

WholeStructuralConstraints::WholeStructuralConstraints()
	: m_feasibleSpaceGroupNumbers{}
	, m_feasibleGeometricalConstraintErrorRate{ 0.0 }
{
}

// Constructor
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// Public methods

void WholeStructuralConstraints::initialize()
{
	m_feasibleSpaceGroupNumbers.clear();
	m_feasibleGeometricalConstraintErrorRate = 0.0;
}

void WholeStructuralConstraints::initializeFromInputFileTexts(const std::string& inputTexts)
{
	initialize();

	OperatingSystem::IO::FileReader::tryReadData(inputTexts, "Feasible.Space.Group.Numbers", m_feasibleSpaceGroupNumbers);
	OperatingSystem::IO::FileReader::tryReadData(inputTexts, "Feasible.Geometrical.Constraint.Error.Rate", m_feasibleGeometricalConstraintErrorRate);
}

// Public methods
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
// **********************************************************************************************************************************************************************************************************************************************************************************************
